//InAuswahlEinfuegen_506d.js
// 04.11.11 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Kopieren und standgleiches Einsetzen eines Bildes in einen leeren Rahmen oder Ersetzen eines vorhandenen

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// das Intervall in Sekunden (wird verglichen mit der Zeit seit
// der letzten Scriptausfhrung: lnger = es wird kopiert;
// krzer = es wird eingesetzt)
var timeDelay = 5;

// die Zeit stoppen und mit dem Eintrag vergleichen
var	copyImg = true;
var curDate = new Date();
var milliSecs = curDate.getTime();
var oldTime = 0;
try {
	oldTime = (app.extractLabel("timeStamp"))*1;
	if ((milliSecs - oldTime) < (timeDelay * 1000)) {
		copyImg = false;
	}
}
catch (e) {
}

// die Millisekunden eintragen
app.insertLabel("timeStamp", ("" + milliSecs));

// eine Referenz zum vordersten Dokument
var curDoc = app.documents[0];

// testen, ob ein Objekt ausgewhlt ist
if (app.selection.length == 0) {
	alert ("Bitte einen Bildrahmen auswhlen.", "Achtung");
	exit();
}

// die Auswahl prfen
var curSel = app.selection[0];
var selType = curSel.constructor.name;
if (selType == "Rectangle" || selType == "Oval" || selType == "Polygon") {
	if (curSel.graphics.length != 0) {
		var curImage = curSel.graphics[0];
	}
	else {
		var curImage = -1;
		copyImg = false;
	}	
}
else if (selType == "Image" || selType == "EPS" || selType == "PDF") {
	var curImage = curSel;
}
else {
	alert ("Die Auswahl ist ungltig.", "Stop");
	exit();
}

// je nach Zeitintervall kopieren oder einfgen
if (copyImg) {
	var curFrame = curImage.parent;
	var fRot = curFrame.rotationAngle;
	var iRot = curImage.absoluteRotationAngle;
	var fShe = curFrame.shearAngle;
	var iShe = curImage.absoluteShearAngle;
	if (fRot !=0) {
		curFrame.rotationAngle = 0;
	}
	if (iRot !=0) {
		curImage.absoluteRotationAngle = 0;
	}
	if (fShe !=0) {
		curFrame.shearAngle = 0;
	}
	if (iShe !=0) {
		curImage.absoluteShearAngle = 0;
	}
	var iGB = curImage.geometricBounds;
	var fGB = curFrame.geometricBounds;
	var hSc = curImage.horizontalScale;
	var vSc = curImage.verticalScale;
	var shiftY = iGB[0]-fGB[0];
	var shiftX = iGB[1]-fGB[1];
	var moveBy = ""+iRot+"#"+iShe+"#"+shiftX+"#"+shiftY+"#"+hSc+"#"+vSc;
	app.insertLabel("shiftVal", moveBy);
	curDoc.select(curImage);
	app.copy();
	if (fRot !=0) {
		curFrame.rotationAngle = fRot;
	}
	if (iRot !=0) {
		curImage.absoluteRotationAngle = iRot;
	}
	if (fShe !=0) {
		curFrame.shearAngle = fShe;
	}
	if (iShe !=0) {
		curImage.absoluteShearAngle = iShe;
	}
	curDoc.select(curSel);
	// verknden, dass das Bild kopiert ist
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Bild ist kopiert.");
	dlog.show();
	// eine kleine Pause
	$.sleep(500);
	// das Fenster schliessen
	dlog.close();
}
else {
	var moveBy = app.extractLabel("shiftVal");
	var params = moveBy.split("#");
	var iRot   = params[0]*1;
	var iShe   = params[1]*1;
	var shiftX = params[2];
	var shiftY = params[3];
	var hSc    = params[4]*1;
	var vSc    = params[5]*1;
	var gRot = curSel.rotationAngle; 
	if (gRot !=0) {
		curSel.rotationAngle = 0;
	}
	var gShe = curSel.shearAngle; 
	if (gShe !=0) {
		curSel.shearAngle = 0;
	}
	if (curImage != -1) {
		curFrame = curImage.parent;
		curImage.remove();
	}
	else {
		curFrame = curSel;
	}
	var fGB = curFrame.geometricBounds;
	var shiftY = fGB[0]+(shiftY*1);
	var shiftX = fGB[1]+(shiftX*1);
	app.selection = curFrame;
	try {
		app.pasteInto();
		if (curFrame.graphics.length != 0) {
			var curImage = curFrame.graphics[0];
			curImage.move([shiftX, shiftY]);
			curImage.horizontalScale = hSc;
			curImage.verticalScale = vSc;
			curFrame.rotationAngle = gRot;
			curImage.absoluteRotationAngle = iRot;
			curFrame.shearAngle = gShe;
			curImage.absoluteShearAngle = iShe;
		}
	}
	catch (e) {
		alert ("Der Inhalt der Zwischenablage kann nicht in diesen Rahmen kopiert werden.", "Achtung");
	}
} 